/* config.h
 *
 * (hacked together by -AJA-)
 *
 * from FreeAmp - The Free MP3 Player
 */

#ifndef CONFIG_H
#define CONFIG_H

#include <limits.h>


/* #undef DEBUG_MUTEXES */
/* #undef USING_DMALLOC */
/* #undef WORDS_BIGENDIAN */

#define HOST_OS "linux"
#define HOST_CPU "i586"

/* #undef ASM_X86 */
/* #undef ASM_X86_OLD */

#define MP3_PROF 0

/* Endian Issues */
#ifdef __LINUX__
#include <endian.h>
#endif /* __LINUX__ */

#ifdef WIN32
#define __LITTLE_ENDIAN 1234
#define __BIG_ENDIAN    4321
#define __PDP_ENDIAN    3412
#define __BYTE_ORDER    __LITTLE_ENDIAN
#endif

/* define our datatypes */
/* real number */
typedef double real;

#if HAVE_BEOS
# include <support/SupportDefs.h>
# include <endian.h>
#else

#if UCHAR_MAX == 0xff

typedef unsigned char	uint8;
typedef signed char	int8;

#else
#error This machine has no 8-bit type
#endif

#if UINT_MAX == 0xffff

typedef unsigned int	uint16;
typedef int		int16;

#elif USHRT_MAX == 0xffff

typedef unsigned short	uint16;
typedef short		int16;

#else
#error This machine has no 16-bit type
#endif

#if UINT_MAX == 0xfffffffful

typedef unsigned int	uint32;
typedef int		int32;

#elif ULONG_MAX == 0xfffffffful

typedef unsigned long	uint32;
typedef long		int32;

#elif USHRT_MAX == 0xfffffffful

typedef unsigned short	uint32;
typedef short		int32;

#else
#error This machine has no 32-bit type
#endif

#endif


#ifndef NULL
#define NULL    ((void *)0)
#endif

#ifndef _MAX_PATH
#define _MAX_PATH 4096
#endif

#ifndef MAX_PATH
#define MAX_PATH 4096
#endif

#ifndef socklen_t
#define socklen_t unsigned int
#endif

/* kludges for beos */
#if HAVE_BEOS
# include <be/kernel/OS.h>
# define usleep(a)	snooze(a)
#endif

#endif /* CONFIG_H */

